--todo text colors for stuff?
--todo slightly randomized x for popups?

JoyScoreCounter = _G.JoyScoreCounter or {}

JoyScoreCounter._localization_path = ModPath .. "loc/"
JoyScoreCounter._options_path = ModPath .. "options.txt"
JoyScoreCounter._saved_settings_path = SavePath .. "JoyScoreSettings.txt"
JoyScoreCounter._saved_highscores_path = SavePath .. "JoyScoreRecords.txt"
JoyScoreCounter._instance = ModInstance
JoyScoreCounter.DEFAULT_LANGUAGE = "english.txt"
JoyScoreCounter._joy_present = nil --used to store whether or not joy is present in the lobby; will not affect JoyScoreCounter's function unless you have enabled the  "Joy must be present" setting

JoyScoreCounter.settings = {
	show_logs = false,--you need to change your save file directly if you want to show logs
	SHOW_ZERO_SCORE_POPUPS = true, --no menu option
	hud_compatibility_mode = false,
	use_custom_popup_position = false,
	popup_x = 0,
	popup_y = 0,
	hud_x = 1024,
	hud_y = 64,
	hud_size = 24,
	popups_enabled = true,
	use_difficulty_multipliers = true,
	require_joy_in_heist = false,
	popup_show_unit_name = true,
	popup_mode = 3, --bob by default. funny, it was my least favorite but it probably looks the best of the three
	popup_fadein = 0.3, --seconds for a popup to fully appear after initial creation
	popup_dur = 0.5, --seconds for a popup to remain fully opaque onscreen
	popup_fadeout = 0.5, --seconds for a popup to fully disappear after the popup_dur has elapsed
--	max_popups = 4, --[NOT IMPLEMENTED] most popups that can be on-screen at once (additional popups will be queued) 
	max_highscores = 10
}

JoyScoreCounter.highscores = {
	{
		level = "heist_branchbank_hl",
		difficulty = "easy_wish",
		duration = 750.48919677734,
		gamemode = 1,
		epoch = 1569669879,
		mutated = false,
		version = "2.0",
		name = "Offyerrocker",
		score = 1292.5
	}
}

JoyScoreCounter.popups = { --will store active point tallies (as hud elements), added as a stack (first in, first out)
--[[ example:
[1] = {
	element = hud:child("popup_1"), 	--assigned upon creation; named incrementally
	start_t = 58 						--assigned by Application:time() upon creation
}
--]]
}

JoyScoreCounter.gamemodes = {
	[1] = "jsc_gamemode_normal",
	[2] = "jsc_gamemode_crimespree", --"cn_crime_spree_level",
	[3] = "menu_cn_skirmish"
}
--you can change point values or add units to this as you see fit. scores are only saved for you anyway
JoyScoreCounter.points_table = { --from https://www.reddit.com/r/paydaytheheist/comments/97lbsd/joys_scoring_system/
	civilian = -25, 
	civilian_female = -25,
	sniper = 3, --sniper
	shield = 5, --shield
	phalanx_minion = 5, --winters shield
	phalanx_vip = 100, --winters
	medic = 6, --medic
	taser = 7, --taser
	spooc = 10, --cloaker 
	tank = 12, --dozer
	tank_hw = 12, --headless dozer
	tank_medic = 12,
	tank_mini = 12,
	shadow_spooc = 100,
	security_undominatable = -1000, --garrett
	mute_security_undominatable = -1000, --also garrett i guess
	security = 1,
	gensec = 1,
	cop = 1,
	cop_scared = 1,
	cop_female = 1,
	fbi = 1,
	swat = 1,
	heavy_swat = 1,
	heavy_swat_sniper = 1,
	fbi_swat = 1,
	fbi_heavy_swat = 1,
	city_swat = 1,
	gangster = 1,
	biker = 1,
	biker_escape = 1,
	mobster = 1,
	mobster_boss = 100, --commissar fucks again asshole
	biker_boss = 100, --the biker heist day 2 boss 
	chavez_boss = 100, --panic room man
	hector_boss = 100, 
	hector_boss_no_armor = 100,
	bolivian = 1,
	bolivian_indoors = 1,
	drug_lord_boss = 100, --sosa
	drug_lord_boss_stealth = 100, --also sosa
	marshal_marksman = 100, --midland ranch marshal boss
	deathvox_guard = 1,
	deathvox_gman = 1,
	deathvox_lightar = 1,
	deathvox_lightshot = 1,
	deathvox_heavyar = 1,
	deathvox_heavyshot = 1,
	deathvox_shield = 5,
	deathvox_medic = 6,
	deathvox_taser = 7,
	deathvox_tank = 12,
	deathvox_cloaker = 10,
	deathvox_sniper = 3,
	deathvox_greendozer = 12,
	deathvox_blackdozer = 12,
	deathvox_lmgdozer = 12,
	deathvox_medicdozer = 12,
	deathvox_guarddozer = 12,
	deathvox_grenadier = 7,
	deathvox_cop_pistol = 1,
	deathvox_cop_smg = 1,
	deathvox_cop_revolver = 1, 
	deathvox_cop_shotgun = 1,
	deathvox_fbi_rookie = 1,
	deathvox_fbi_hrt = 1,
	deathvox_fbi_veteran = 1
}

JoyScoreCounter.difficulty_multipliers = {
	easy = 0.5,
	normal = 1,
	overkill = 2,
	overkill_145 = 4,
	easy_wish = 6,
	overkill_290 = 7,
	sm_wish = 10
}

JoyScoreCounter.popups_count = 0
JoyScoreCounter.current_score = 0
JoyScoreCounter.current_level = "jsc_unknown_level"
JoyScoreCounter.current_gamemode = "jsc_unknown_gamemode"

local max_highscores = 10
local headshot_multiplier = 1 --not used, but you can enable it by setting your own headshot multiplier

--settings

function JoyScoreCounter:IsHUDCompatibilityMode()
	return self.settings.hud_compatibility_mode
end

function JoyScoreCounter:IsJoyRequired()
	return self.settings.require_joy_in_heist
end

--utils


function JoyScoreCounter:Log(...)
	if not self.settings.show_logs then 
		return
	end
	if Console then 
		Console:Log(...)
	else
		log(...)
	end
end

function JoyScoreCounter:len(s,b)
	if alive(self._joy_score_counter_base) then 
		local text = self._joy_score_counter_base:child("jsc_debug_text")
		text:set_text(tostring(s))
		local _,_,w,_ = text:text_rect()
		return w
	end
	return b
end

function JoyScoreCounter.FormatTime(t,b)
	if type(t) ~= "number" then 
		return b
	end
	
	local minutes = t / 60
	local hours = minutes / 60
	local days = hours / 24
	
	minutes = math.floor(minutes % 60)
	hours = math.floor(hours % 24)
	days = math.floor(days)
	
	local result = ""
	
	result = math.floor(t % 60) .. "s" --seconds
	
	if minutes > 0.1 then 
		result = minutes .. "m " .. result
	end
	if hours > 0.1 then 
		result = hours .. "h " .. result
	end
	if days > 0.1 then 
		result = days .. "d " .. result .. "- Wait, really? Holy crap."
	end
	return result
end

function JoyScoreCounter.FormatDateOf(d)
	if d then 
		local mm = string.sub(d,1,2)
		local dd = string.sub(d,3,4)
		local yyyy = string.sub(d,5,8)
		return string.format("%02d/%02d/%04d", mm, dd, yyyy)
	else
		return "01/01/1999"
	end
end

--mostly HUD stuff 

Hooks:Register("JoyScoreCounter_SetScore") --for add-ons if other people choose to write them

function JoyScoreCounter:CreateHUD(parent)
	if self:IsHUDCompatibilityMode() then 
		if not parent then 
			if self._workspace then 
				self:Log("Attempted to create JoyScoreCounter HUD again!")
				parent = self._workspace
			else
				self._workspace = managers.gui_data:create_fullscreen_workspace()
				parent = self._workspace:panel()
			end
		end
	else
		self._workspace = false
		parent = parent or managers.hud and managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2) and managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2).panel
	end
	if not parent then 
		return
	end
	if alive(parent:child("joyscorecounter_base")) then 
		parent:remove(parent:child("joyscorecounter_base"))
	end
	
	local jsc_base = parent:panel({
		name = "joyscorecounter_base",
		halign = "grow",
		valign = "bottom"
	})
	
	local jsc_debug_text = jsc_base:text({
		name = "jsc_debug_text",
		text = "",
		font = tweak_data.hud.medium_font,
		font_size = 16,
		color = Color.white,
		visible = false,
	})
	
	
	
	--[[ alternatives:
	Gamemode._NAME
	game_state_machine:gamemode().id == GamemodeCrimeSpree.id
	Global.game_settings.gamemode == GamemodeCrimeSpree.id
	--]]
	
	self._joy_score_counter_base = jsc_base

		
	local counter_value = jsc_base:text({
		name = "counter",
		layer = 1,
		text = "SCORE: 0",
		font = "fonts/font_large_mf",
		font_size = self.settings.hud_size or 24, -- shitty hack by Mercu
		x = 0, --changed on loading into the heist (event playermanager:internal_load())
		y = 0,
		alpha = 1,
		color = Color.white
	})
	
	managers.hud:remove_updator("joyscore_updator") --if present, remove updator
	managers.hud:add_updator("joyscore_updator",callback(self,self,"UpdateHUD"))
end

function JoyScoreCounter:SetHUDVisible(state)
	if self._joy_score_counter_base and alive(self._joy_score_counter_base) then 
		if state == nil then 
			return			
		else
			self._joy_score_counter_base:set_visible(state)
			return
		end
	end
end

Hooks:Add("BaseNetworkSessionOnPeerEnteredLobby","jsc_on_peer_entered_lobby",function(peer,peer_id)
	JoyScoreCounter:CheckJoyPresent()
end)

Hooks:Add("BaseNetworkSessionOnPeerRemoved","jsc_on_peer_removed",function(peer,peer_id)
	JoyScoreCounter:CheckJoyPresent()
end)

function JoyScoreCounter:CheckJoyPresent()
	if managers.criminals and managers.criminals:has_character_by_name("joy") then
		self._joy_present = true
	else
		self:SetHUDVisible(false)
		return
	end
end

function JoyScoreCounter:UpdateHUD(t,dt)
	if not managers.player:local_player() then 
		self:SetHUDVisible(false)
		return
	end
	
	if self:IsJoyRequired() then 
		if not self._joy_present then 
			return
		end
	end
	self:SetHUDVisible(true)
	
	local dur = math.max(0.01,self.settings.popup_dur or 2)
	local fade_out = self.settings.popup_fadeout or 1
	local fade_in = self.settings.popup_fadein or 0.25
	local _t = Application:time() -- t passed from updator doesn't always match Application:time()
	local style = self.settings.popup_mode
	--1 is queue (uses calculated, absolute progression)
	--2 is stack (calculated, absolute progression)
	--3 is bob (uses quadratic, relative progression off of current position)
	
--	local popup_x = self._joy_score_counter_base:w() / 2
	local popup_y = self._joy_score_counter_base:h() / 2
	
	local iteration = 0 --in effect, row number. disabled for "Bob" style 
	local v_margin = 16 --space per row
	local v_offset = 0 --total delta y after calculations
	local queued_cull = {}
	for id,popup in pairs(self.popups) do 
		if style == 1 then 
			iteration = iteration + 1
		end
	
		local start_t = popup and popup.start_t 
		local element = popup and popup.element
		if not (popup and start_t and element) or (start_t + fade_in + dur + fade_out < _t) then 
			table.insert(queued_cull,id)
		elseif alive(element) then 
			local d_a = 1 --final alpha calculation
			local d_t = 0 --progress through any given phase
--			local c_alpha = element:alpha()
			
			-- fadein/out is quadratic, using the formula: 
			--	alpha   =  ( duration - (t ^ 2) ) / duration
			if start_t + fade_in > _t then --start fadein
				d_t = math.abs(start_t - _t) - fade_in
--				d_t = (_t - (start_t)) --must be reversed; this line results in a fadeout
				d_a = (fade_in - (d_t * d_t)) / fade_in
				v_offset = v_margin * (iteration + 1 - d_a)
			elseif start_t + fade_in + dur > _t then --main duration; hold alpha 1
				v_offset = v_margin * iteration
				d_a = 1
--				d_t = _t - (start_t + fade_in) --not necessary to calculate since alpha is constant in this phase
			elseif start_t + fade_in + dur + fade_out > _t then  --start fadeout
				d_t = (style == 3 and 1 or 2) * (_t - (start_t + fade_in + dur))
				d_a = (fade_out - (d_t * d_t)) / fade_out
				v_offset = v_margin * (iteration - math.pow(d_t,1.5))
			end
--			local c_x = element:x()
			local c_y = element:y()
--			local d_x = c_x - popup_x
--			local d_y = c_y - popup_y
--			element:set_x(popup_x)
			element:set_alpha(d_a)
			if style == 1 or style == 2 then 
				element:set_y(popup_y + v_offset)
			else
				element:set_y(c_y + v_offset)
			end
		end
	end
	local base = self._joy_score_counter_base
	for queue_id,popup_id in pairs(queued_cull) do 
		base:remove(self.popups[popup_id].element)
		self.popups[popup_id] = nil
	end
end

function JoyScoreCounter:GetLocalizedUnitName(unit_name)
	if not unit_name then
		return "unknown"
	end
	
	local name = managers.localization:text("jsc_unit_" .. unit_name)
	if HopLib and string.find(name,"ERROR") then 
		local name_provider = HopLib:name_provider()
		name = name_provider:name_by_id(unit_name)
	end
	return name or unit_name
end

function JoyScoreCounter:OnKill(unit_name,headshot)
	unit_name = unit_name or "nil" --so we don't crash from indexing nil
	local score = self.points_table[unit_name]
	if not score then
		self:Log(unit_name .. " has no score value")
		return
	end --unit has no score entry
	score = score * (headshot and headshot_multiplier or 1) * (self.settings.use_difficulty_multipliers and self.difficulty_multipliers[Global.game_settings.difficulty] or 1)
	if score == 0 and not self.settings.SHOW_ZERO_SCORE_POPUPS then 
		return
	end
	if self.settings.popups_enabled then
		self.popups_count = self.popups_count + 1 --total count, not currently active count
		
		local localized_unit_name = self:GetLocalizedUnitName(unit_name) 
		
		local v_margin = 16
		local h_margin = 32
		
		local base = self._joy_score_counter_base
		
		local color = (score >= 0) and Color.white or Color.red
		local popup = base:text({
			name = "popup_" .. tostring(self.popups_count),
			layer = 1,
			text = (score > 0 and "+" or "") .. tostring(score) .. (self.settings.popup_show_unit_name and (" " .. localized_unit_name) or ""),
			font = "fonts/font_large_mf",
			font_size = 16,
			x = (base:w() / 2) + h_margin,
			y = (base:h() / 2) + (#self.popups * v_margin), --x and y changed on loading into the heist
			alpha = 0,
			color = color
		})

		table.insert(self.popups,{start_t = Application:time(),element = popup})
	end
	
	self.current_score = self.current_score + score
	self:SetJoyCounter(string.gsub(managers.localization:text("jsc_counter_score_text"),"$NUM",string.format("%i",self.current_score)))
	Hooks:Call("JoyScoreCounter_SetScore",self.current_score,score)
end

--set HUD score counter string
function JoyScoreCounter:SetJoyCounter(str)
	local base = self._joy_score_counter_base
	local counter = base:child("counter")	
	counter:set_text(str)
end

function JoyScoreCounter:SetJoyCounterX(val)
	local base = self._joy_score_counter_base
	if val and alive(base) then 
		local counter = base:child("counter")
		counter:set_x(val)
	end
end

function JoyScoreCounter:SetJoyCounterY(val)
	local base = self._joy_score_counter_base
	if val and alive(base) then 
		local counter = base:child("counter")
		counter:set_y(val)
	end
end

function JoyScoreCounter:SetJoyCounterSize(val)
	local base = self._joy_score_counter_base
	if val and alive(base) then 
		local debug_text = base:child("jsc_debug_text")
		debug_text:set_font_size(val)
		
		local counter = base:child("counter")
		counter:set_font_size(val)
	end
end

--mostly menu/highscore saving stuff

function JoyScoreCounter:OnMissionEnd(data,session_time) --save highscore
	local hs_count = #self.highscores
	
	local peer = managers.network:session():local_peer()
	local name = peer and peer:name() or "A. A. Aaronson"
	
	--[[ old date method
	local date_raw = tostring(Application:date())
	local y = string.sub(date_raw,1,4)
	local m = string.sub(date_raw,6,7)
	local d = string.sub(date_raw,9,10)
	local date_of = m .. d .. y
	
--i guess you could say this way is somewhat... DATED? 
--bad_joke_eel.jpg
	--]]
	
	local max_highscores = self.settings.max_highscores
	
	local level_data = managers.job:current_level_data() or {}
	local current_level = level_data.name_id or "jsc_unknown_level"
	local current_gamemode = 1
	if level_data.group_ai_state == "skirmish" then 
		current_gamemode = 3
	elseif managers.crime_spree:is_active() then 
		current_gamemode = 2
	end
	local new_highscore = {
		name = name,
		score = self.current_score,
		epoch = os.time(),
		level = current_level,
		gamemode = current_gamemode,
		difficulty = Global.game_settings.difficulty,
		duration = session_time or managers.game_play_central:get_heist_timer(),--alternatively use TimerManager:game():time() ?
		mutated = managers.mutators:are_mutators_enabled(),
		from_start = not not Global.statistics_manager.playing_from_start,
		victory = data.success,
		version = self._instance.version
	}
	
	
	if (hs_count < max_highscores) or (new_highscore.score > self.highscores[hs_count].score) then
		for k,entry in pairs(self.highscores) do 
			if (entry.score < new_highscore.score) then 	
				table.insert_sorted(self.highscores,new_highscore,function(a,b)
					return a.score > b.score
				end) --prepend?
				break
			end
		end
	end
	for k,v in pairs(self.highscores) do
		if k > max_highscores then
			self.highscores[k] = nil
			--remove all but the top [max_highscores] scores
		end
	end
	
	self:Save()
end

function JoyScoreCounter:ShowHighscores()

	table.sort(self.highscores,function(a,b)
		return a.score > b.score
	end)
	
	local options = {}
	for k,entry in pairs(self.highscores) do
		if not entry then break end
		local score = entry.score or "-"
		local name = entry.name or "-"
		
		
		local date_of = entry.date_of
		local epoch = entry.epoch
		local date_formatted = "ERROR"
		if epoch then 
			date_formatted = os.date("%x",epoch)
		elseif date_of then 
			date_formatted = self.FormatDateOf(date_of)
		end
		
		
		local free_space = math.max(3,30 - string.len(score))
		local whitespace = string.rep(" ",free_space)
		name = string.sub(name,1,math.min(string.len(name),free_space))
		table.insert(options,{
			text = k .. "." .. whitespace .. score .. " - " .. name .. " : " .. date_formatted,
			callback = callback(self,self,"ShowHighscoreDetail",{entry = entry,rank = k})
--			is_cancel_button = true
		})
	end
	table.insert(options,{
		text = managers.localization:text("jsc_back"),
		is_cancel_button = true
	})
	local menu_title = managers.localization:text("jsc_highscores_title")
	local menu_desc = managers.localization:text("jsc_highscores_desc")
	QuickMenu:new(menu_title,menu_desc,options,true)
end

function JoyScoreCounter:ShowHighscoreDetail(params)

	local i = params.rank
	local entry = params.entry

	local menu_title = string.gsub(managers.localization:text("jsc_entry_header"),"$$RANK",i) -- or managers.localization:text("jsc_highscores_title")
	local menu_desc = ""
	
	local function ass(title,value) --AppendStringS but shortened also haha "ass"
		local space_len = self:len(" ",1)
		local free_space = math.round(math.max((self:len("      ",1) * space_len) - self:len(title,0) / space_len,1))
		
		menu_desc = menu_desc .. title .. string.rep(" ",free_space) .. tostring(value) .. "\n"
	end
	if entry then 
		ass(managers.localization:text("jsc_entry_name"),entry.name or "-")
		ass(managers.localization:text("jsc_entry_score"),entry.score or "-")
		ass(managers.localization:text("jsc_entry_date"),(entry.date_of and self.FormatDateOf(entry.date_of)) or entry.epoch and (os.date("%c",entry.epoch)) or "-")
		ass(managers.localization:text("jsc_entry_difficulty"),(entry.difficulty and managers.localization:text(tweak_data.difficulty_name_ids[entry.difficulty])) or "-")
		ass(managers.localization:text("jsc_entry_level"),(entry.level and managers.localization:text(entry.level) or "-"))
		ass(managers.localization:text("jsc_entry_gamemode"),(entry.gamemode and managers.localization:text(self.gamemodes[entry.gamemode] or "jsc_unknown_gamemode") or "-"))
		ass(managers.localization:text("jsc_entry_victory"),(entry.victory ~= nil and tostring(entry.victory)) or "-")
		ass(managers.localization:text("jsc_entry_fromstart"),entry.from_start ~= nil and tostring(entry.from_start) or "-")
		ass(managers.localization:text("jsc_entry_time"),entry.duration and ((tonumber(entry.duration) ~= nil) and self.FormatTime(tonumber(entry.duration),"-")) or "-")
		ass(managers.localization:text("menu_mutators"),(entry.mutated ~= nil and managers.localization:text(entry.mutated and "jsc_mutators_enabled" or "jsc_mutators_disabled")) or "-")
	else
		menu_desc = "ERROR"
		self:Log("Error! ShowHighscoreDetail: No highscore found")
	end
	
	local options = {
		{
			text = managers.localization:text("jsc_back"),
			callback = callback(self,self,"ShowHighscores")
		}
	}
	QuickMenu:new(menu_title,menu_desc,options,true)
end


function JoyScoreCounter:Load(skip_settings,skip_highscores) --returns true if is first time setup
	
	local settings_file = io.open(JoyScoreCounter._saved_settings_path,"r")
	local highscores_file = io.open(JoyScoreCounter._saved_highscores_path, "r")
	
	if settings_file and not skip_settings then
		for setting, value in pairs(json.decode(settings_file:read("*all"))) do
			self.settings[setting] = value
		end
	end
	if highscores_file and not skip_highscores then
		for k,v in pairs(json.decode(highscores_file:read("*all"))) do
			self.highscores[k] = v
		end
	end
	
	if not (settings_file and highscores_file) then 
		self:Save()
	else
		return true
	end
end

function JoyScoreCounter:Save()
	local settings_file = io.open(JoyScoreCounter._saved_settings_path,"w+")
	if settings_file then
		settings_file:write(json.encode(self.settings))
		settings_file:close()
	end
	local highscores_file = io.open(JoyScoreCounter._saved_highscores_path,"w+")
	if highscores_file then
		highscores_file:write(json.encode(self.highscores))
		highscores_file:close()
	end
end

Hooks:Add("BaseNetworkSessionOnLoadComplete","jsc_ongameloadcomplete",function()
	if managers.hud then
		JoyScoreCounter:CreateHUD()
		JoyScoreCounter:SetJoyCounterX(JoyScoreCounter.settings.hud_x)
		JoyScoreCounter:SetJoyCounterY(JoyScoreCounter.settings.hud_y)
		JoyScoreCounter:SetJoyCounterSize(JoyScoreCounter.settings.hud_size)
		if JoyScoreCounter._joy_score_counter_base and alive(JoyScoreCounter._joy_score_counter_base) then
			if not (game_state_machine and GameStateFilters.any_ingame[game_state_machine:current_state_name()]) then
				JoyScoreCounter:SetHUDVisible(false)
			end
		end
	end
end)

Hooks:Add("LocalizationManagerPostInit", "jsc_LocalizationManagerPostInit", function( loc )
	local path = JoyScoreCounter._localization_path
	loc:add_localized_strings({jsc_unit_nil="oopsie woopsie OwO uwu i made a fuckie wuckie~ a widdle fucko boingo!!! ugu~"})
	if not BeardLib then 
		loc:load_localization_file(path .. JoyScoreCounter.DEFAULT_LANGUAGE)
	end
end)

Hooks:Add( "MenuManagerInitialize", "jsc_MenuManagerInitialize", function(menu_manager)

	MenuCallbackHandler.callback_jsc_toggle_hud_compatibility = function(self,item)
		JoyScoreCounter.settings.hud_compatibility_mode = item:value() == "on"
		JoyScoreCounter:Save()
	end
	MenuCallbackHandler.callback_jsc_toggle_popups = function(self,item)
		JoyScoreCounter.settings.popups_enabled = item:value() == "on"
		JoyScoreCounter:Save()
	end
	
	MenuCallbackHandler.callback_jsc_toggle_unit_names = function(self,item)
		JoyScoreCounter.settings.popup_show_unit_name = item:value() == "on"
		JoyScoreCounter:Save()
	end
	
	MenuCallbackHandler.callback_jsc_popup_mode = function(self,item)
		JoyScoreCounter.settings.popup_mode = tonumber(item:value())
		JoyScoreCounter:Save()
	end
	
	MenuCallbackHandler.callback_jsc_hud_x = function(self,item)
		local value = tonumber(item:value())
		JoyScoreCounter.settings.hud_x = value
		if alive(JoyScoreCounter._joy_score_counter_base) then 
			JoyScoreCounter:SetJoyCounterX(value)
		end
		JoyScoreCounter:Save()
	end
	
	MenuCallbackHandler.callback_jsc_hud_y = function(self,item)
		local value = tonumber(item:value())
		JoyScoreCounter.settings.hud_y = value
		if alive(JoyScoreCounter._joy_score_counter_base) then 
			JoyScoreCounter:SetJoyCounterY(value)
		end
		JoyScoreCounter:Save()
	end
	
	MenuCallbackHandler.callback_jsc_hud_size = function(self,item)
		local value = tonumber(item:value())
		JoyScoreCounter.settings.hud_size = value
		if alive(JoyScoreCounter._joy_score_counter_base) then 
			JoyScoreCounter:SetJoyCounterSize(value)
		end
		JoyScoreCounter:Save()
	end
	
	MenuCallbackHandler.callback_jsc_show_highscores = function(self)
		JoyScoreCounter:ShowHighscores()
	end
	JoyScoreCounter:Load()
	
	MenuHelper:LoadFromJsonFile(JoyScoreCounter._options_path, JoyScoreCounter, JoyScoreCounter.settings)
end)